package com.DevAsh.downloader;

import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;
import io.flutter.plugin.common.MethodChannel.MethodCallHandler;
import io.flutter.plugin.common.MethodChannel.Result;
import io.flutter.plugin.common.PluginRegistry.Registrar;
import 	android.os.Environment;
import 	android.app.ProgressDialog;
import 	android.content.Context;
import 	android.app.Activity;
import 	android.os.AsyncTask;
import 	android.os.PowerManager;
import 	java.net.HttpURLConnection;
import 	java.io.FileOutputStream;
import android.content.DialogInterface;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.URL;
import android.content.pm.PackageManager;
import android.net.Uri;
import android.widget.Toast;
import android.Manifest;
import 	android.os.Build;
import 	android.app.DownloadManager;


import 	android.content.Intent;
import 	android.os.ResultReceiver;
import android.os.Handler;
import 	android.os.Bundle;
import android.content.Intent;
import 	android.app.IntentService;
import 	android.app.Dialog;


/** DownloaderPlugin */
public class DownloaderPlugin implements MethodCallHandler {

  final int PERMISSION_CODE = 1000;
  String url;
  String name;
  String ext;
  /** Plugin registration. */
  public static void registerWith(Registrar registrar) {
    final MethodChannel channel = new MethodChannel(registrar.messenger(), "downloader");
    channel.setMethodCallHandler(new DownloaderPlugin(registrar.activity()));
  }
  
  Activity activity;

  DownloaderPlugin(Activity activity){
    this.activity=activity;
  }

  @Override
  public void onMethodCall(MethodCall call, Result result) {
    if (call.method.equals("getPlatformVersion")) {
      result.success("Android " + android.os.Build.VERSION.RELEASE);
    }else if(call.method.equals("getPermission")){
      if(activity.checkSelfPermission(Manifest.permission.WRITE_EXTERNAL_STORAGE)==PackageManager.PERMISSION_DENIED){

        String[] permissions = {Manifest.permission.WRITE_EXTERNAL_STORAGE};
        activity.requestPermissions(permissions,PERMISSION_CODE);

        }
    }else  if (call.method.equals("Download")) {
         url = call.argument("url");
         name = call.argument("Name");
         ext = call.argument("ext");
         if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.M){
         if(activity.checkSelfPermission(Manifest.permission.WRITE_EXTERNAL_STORAGE)==PackageManager.PERMISSION_DENIED){

             String[] permissions = {Manifest.permission.WRITE_EXTERNAL_STORAGE};
             activity.requestPermissions(permissions,PERMISSION_CODE);

         }else{
            startDownloading();
         }
        }else{
          startDownloading();
        }
    }
  }

  public void startDownloading(){
     
    DownloadManager.Request request = new DownloadManager.Request(Uri.parse(url));
    request.setAllowedNetworkTypes(DownloadManager.Request.NETWORK_WIFI | DownloadManager.Request.NETWORK_MOBILE);
    request.setTitle(name);
    request.setDescription("Downloading files");
    request.allowScanningByMediaScanner();
    request.setNotificationVisibility(DownloadManager.Request.VISIBILITY_VISIBLE_NOTIFY_COMPLETED);
    request.setDestinationInExternalPublicDir(Environment.DIRECTORY_DOWNLOADS,"/"+name+ext);

    DownloadManager manager = (DownloadManager) activity.getSystemService(activity.DOWNLOAD_SERVICE);
    manager.enqueue(request);

  }

 
  public void onRequestPermissionsResult(int requestCode,String[] permission,int[] grantPermission ){
         switch(requestCode){
           case PERMISSION_CODE:{
             if(grantPermission.length>0 && grantPermission[0]==PackageManager.PERMISSION_GRANTED ){
                startDownloading();
             }else{
               Toast.makeText(activity,"Error",Toast.LENGTH_SHORT).show();
             }
           }
         }
  }
}